package graph

import (
    i336074805fc853987abe6f7fe3ad97a6a6f3077a16391fec744f671a015fbd7e "time"
    i04eb5309aeaafadd28374d79c8471df9b267510b4dc2e3144c378c50f6fd7b55 "github.com/microsoft/kiota/abstractions/go/serialization"
)

// Groupable 
type Groupable interface {
    DirectoryObjectable
    i04eb5309aeaafadd28374d79c8471df9b267510b4dc2e3144c378c50f6fd7b55.Parsable
    GetAcceptedSenders()([]DirectoryObjectable)
    GetAllowExternalSenders()(*bool)
    GetAppRoleAssignments()([]AppRoleAssignmentable)
    GetAssignedLabels()([]AssignedLabelable)
    GetAssignedLicenses()([]AssignedLicenseable)
    GetAutoSubscribeNewMembers()(*bool)
    GetCalendar()(Calendarable)
    GetCalendarView()([]Eventable)
    GetClassification()(*string)
    GetConversations()([]Conversationable)
    GetCreatedDateTime()(*i336074805fc853987abe6f7fe3ad97a6a6f3077a16391fec744f671a015fbd7e.Time)
    GetCreatedOnBehalfOf()(DirectoryObjectable)
    GetDescription()(*string)
    GetDisplayName()(*string)
    GetDrive()(Driveable)
    GetDrives()([]Driveable)
    GetEvents()([]Eventable)
    GetExpirationDateTime()(*i336074805fc853987abe6f7fe3ad97a6a6f3077a16391fec744f671a015fbd7e.Time)
    GetExtensions()([]Extensionable)
    GetGroupLifecyclePolicies()([]GroupLifecyclePolicyable)
    GetGroupTypes()([]string)
    GetHasMembersWithLicenseErrors()(*bool)
    GetHideFromAddressLists()(*bool)
    GetHideFromOutlookClients()(*bool)
    GetIsArchived()(*bool)
    GetIsAssignableToRole()(*bool)
    GetIsSubscribedByMail()(*bool)
    GetLicenseProcessingState()(LicenseProcessingStateable)
    GetMail()(*string)
    GetMailEnabled()(*bool)
    GetMailNickname()(*string)
    GetMemberOf()([]DirectoryObjectable)
    GetMembers()([]DirectoryObjectable)
    GetMembershipRule()(*string)
    GetMembershipRuleProcessingState()(*string)
    GetMembersWithLicenseErrors()([]DirectoryObjectable)
    GetOnenote()(Onenoteable)
    GetOnPremisesDomainName()(*string)
    GetOnPremisesLastSyncDateTime()(*i336074805fc853987abe6f7fe3ad97a6a6f3077a16391fec744f671a015fbd7e.Time)
    GetOnPremisesNetBiosName()(*string)
    GetOnPremisesProvisioningErrors()([]OnPremisesProvisioningErrorable)
    GetOnPremisesSamAccountName()(*string)
    GetOnPremisesSecurityIdentifier()(*string)
    GetOnPremisesSyncEnabled()(*bool)
    GetOwners()([]DirectoryObjectable)
    GetPermissionGrants()([]ResourceSpecificPermissionGrantable)
    GetPhoto()(ProfilePhotoable)
    GetPhotos()([]ProfilePhotoable)
    GetPlanner()(PlannerGroupable)
    GetPreferredDataLocation()(*string)
    GetPreferredLanguage()(*string)
    GetProxyAddresses()([]string)
    GetRejectedSenders()([]DirectoryObjectable)
    GetRenewedDateTime()(*i336074805fc853987abe6f7fe3ad97a6a6f3077a16391fec744f671a015fbd7e.Time)
    GetSecurityEnabled()(*bool)
    GetSecurityIdentifier()(*string)
    GetSettings()([]GroupSettingable)
    GetSites()([]Siteable)
    GetTeam()(Teamable)
    GetTheme()(*string)
    GetThreads()([]ConversationThreadable)
    GetTransitiveMemberOf()([]DirectoryObjectable)
    GetTransitiveMembers()([]DirectoryObjectable)
    GetUnseenCount()(*int32)
    GetVisibility()(*string)
    SetAcceptedSenders(value []DirectoryObjectable)()
    SetAllowExternalSenders(value *bool)()
    SetAppRoleAssignments(value []AppRoleAssignmentable)()
    SetAssignedLabels(value []AssignedLabelable)()
    SetAssignedLicenses(value []AssignedLicenseable)()
    SetAutoSubscribeNewMembers(value *bool)()
    SetCalendar(value Calendarable)()
    SetCalendarView(value []Eventable)()
    SetClassification(value *string)()
    SetConversations(value []Conversationable)()
    SetCreatedDateTime(value *i336074805fc853987abe6f7fe3ad97a6a6f3077a16391fec744f671a015fbd7e.Time)()
    SetCreatedOnBehalfOf(value DirectoryObjectable)()
    SetDescription(value *string)()
    SetDisplayName(value *string)()
    SetDrive(value Driveable)()
    SetDrives(value []Driveable)()
    SetEvents(value []Eventable)()
    SetExpirationDateTime(value *i336074805fc853987abe6f7fe3ad97a6a6f3077a16391fec744f671a015fbd7e.Time)()
    SetExtensions(value []Extensionable)()
    SetGroupLifecyclePolicies(value []GroupLifecyclePolicyable)()
    SetGroupTypes(value []string)()
    SetHasMembersWithLicenseErrors(value *bool)()
    SetHideFromAddressLists(value *bool)()
    SetHideFromOutlookClients(value *bool)()
    SetIsArchived(value *bool)()
    SetIsAssignableToRole(value *bool)()
    SetIsSubscribedByMail(value *bool)()
    SetLicenseProcessingState(value LicenseProcessingStateable)()
    SetMail(value *string)()
    SetMailEnabled(value *bool)()
    SetMailNickname(value *string)()
    SetMemberOf(value []DirectoryObjectable)()
    SetMembers(value []DirectoryObjectable)()
    SetMembershipRule(value *string)()
    SetMembershipRuleProcessingState(value *string)()
    SetMembersWithLicenseErrors(value []DirectoryObjectable)()
    SetOnenote(value Onenoteable)()
    SetOnPremisesDomainName(value *string)()
    SetOnPremisesLastSyncDateTime(value *i336074805fc853987abe6f7fe3ad97a6a6f3077a16391fec744f671a015fbd7e.Time)()
    SetOnPremisesNetBiosName(value *string)()
    SetOnPremisesProvisioningErrors(value []OnPremisesProvisioningErrorable)()
    SetOnPremisesSamAccountName(value *string)()
    SetOnPremisesSecurityIdentifier(value *string)()
    SetOnPremisesSyncEnabled(value *bool)()
    SetOwners(value []DirectoryObjectable)()
    SetPermissionGrants(value []ResourceSpecificPermissionGrantable)()
    SetPhoto(value ProfilePhotoable)()
    SetPhotos(value []ProfilePhotoable)()
    SetPlanner(value PlannerGroupable)()
    SetPreferredDataLocation(value *string)()
    SetPreferredLanguage(value *string)()
    SetProxyAddresses(value []string)()
    SetRejectedSenders(value []DirectoryObjectable)()
    SetRenewedDateTime(value *i336074805fc853987abe6f7fe3ad97a6a6f3077a16391fec744f671a015fbd7e.Time)()
    SetSecurityEnabled(value *bool)()
    SetSecurityIdentifier(value *string)()
    SetSettings(value []GroupSettingable)()
    SetSites(value []Siteable)()
    SetTeam(value Teamable)()
    SetTheme(value *string)()
    SetThreads(value []ConversationThreadable)()
    SetTransitiveMemberOf(value []DirectoryObjectable)()
    SetTransitiveMembers(value []DirectoryObjectable)()
    SetUnseenCount(value *int32)()
    SetVisibility(value *string)()
}
